# Copyright (C) 2016-2024 RhodeCode GmbH
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License, version 3
# (only), as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This program is dual-licensed. If you wish to learn more about the
# RhodeCode Enterprise Edition, including its added features, Support services,
# and proprietary license terms, please see https://rhodecode.com/licenses/

import time
import logging

import rhodecode
from rhodecode.lib.auth import AuthUser
from rhodecode.lib.base import get_ip_addr, get_user_agent
from rhodecode.lib.middleware.utils import get_path_info
from rhodecode.lib.utils2 import safe_str, get_current_rhodecode_user


log = logging.getLogger(__name__)


class RequestWrapperTween:
    def __init__(self, handler, registry):
        self.handler = handler
        self.registry = registry

        # one-time configuration code goes here

    def _get_user_info(self, request):
        user = get_current_rhodecode_user(request)
        if not user:
            user = AuthUser.repr_user(ip=get_ip_addr(request.environ))
        return user

    def __call__(self, request):
        start = time.time()
        _path = get_path_info(request.environ)
        _method = request.environ.get("REQUEST_METHOD")

        log.debug("Starting request processing: %s Request to %s", _method, _path)
        response = None
        request.req_wrapper_start = start

        try:
            response = self.handler(request)
        finally:
            ua = get_user_agent(request.environ)
            count = request.request_count()
            _ver_ = rhodecode.__version__
            ip = get_ip_addr(request.environ)
            match_route = request.matched_route.name if request.matched_route else "NOT_FOUND"
            resp_code = getattr(response, "status_code", "UNDEFINED")

            req_id = getattr(request, "req_id", None)
            _auth_user = self._get_user_info(request)

            total = time.time() - start
            log.info(
                "Finished request processing: %s Request to %s req[%4s] %s time: %.4fs [%s], RhodeCode %s req_id=%s",
                _method,
                _path,
                count,
                _auth_user,
                total,
                ua,
                _ver_,
                req_id,
                extra={
                    "time": total,
                    "ver": _ver_,
                    "code": resp_code,
                    "path": _path,
                    "view_name": match_route,
                    "user_agent": ua,
                    "ip": ip,
                },
            )
            if response:
                response.headers.setdefault("X-Rc-Req-Id", req_id)

            statsd = request.registry.statsd
            if statsd:
                elapsed_time_ms = round(1000.0 * total)  # use ms only
                statsd.timing(
                    "rhodecode_req_timing.histogram",
                    elapsed_time_ms,
                    tags=[f"view_name:{match_route}", f"code:{resp_code}"],
                    use_decimals=False,
                )
                statsd.incr("rhodecode_req_total", tags=[f"view_name:{match_route}", f"code:{resp_code}"])

        return response


def includeme(config):
    config.add_tween(
        "rhodecode.lib.middleware.request_wrapper.RequestWrapperTween",
    )
